#include <QGuiApplication>
#include <QQmlApplicationEngine>
#include <QtQml/qqmlextensionplugin.h>
#include <QTranslator>
#include <QLibraryInfo>

Q_IMPORT_QML_PLUGIN(duck_tickPlugin)
Q_IMPORT_QML_PLUGIN(duck_trackPlugin)

int main(int argc, char *argv[])
{
    Q_INIT_RESOURCE(apptranslations);
    Q_INIT_RESOURCE(duckticktranslations);
    Q_INIT_RESOURCE(ducktracktranslations);
    QGuiApplication app(argc, argv);

    // Load translations
    QLocale locale;
    qCritical() << locale.name();

    auto qtTranslator = new QTranslator();
    if (qtTranslator->load("qt_" + locale.name(), QLibraryInfo::path(QLibraryInfo::TranslationsPath))) {
        app.installTranslator(qtTranslator);
    }

    // Custom translations
    auto appTranslator = new QTranslator();
    if (appTranslator->load(locale, QLatin1String("app"), QLatin1String("_"), QLatin1String(":/translations"))) {
        app.installTranslator(appTranslator);
    }
    auto tickTranslator = new QTranslator();
    if (tickTranslator->load(locale, QLatin1String("tick"), QLatin1String("_"), QLatin1String(":/translations"))) {
        app.installTranslator(tickTranslator);
	qCritical() << "yey";
    }
    auto trackTranslator = new QTranslator();
    if (trackTranslator->load(locale, QLatin1String("track"), QLatin1String("_"), QLatin1String(":/translations"))) {
        app.installTranslator(trackTranslator);
	qCritical() << "yey";
    }

    QQmlApplicationEngine engine;
    engine.addImportPath(":/");
    const QUrl url(u"qrc:/duck/main.qml"_qs);
    QObject::connect(&engine, &QQmlApplicationEngine::objectCreated,
                     &app, [url](QObject *obj, const QUrl &objUrl) {
        if (!obj && url == objUrl)
            QCoreApplication::exit(-1);
    }, Qt::QueuedConnection);
    engine.load(url);

    qCritical() << QObject::tr("I'm in C++...");

    return app.exec();
}
